Loading...
Searching...
No Matches
juce::AudioDeviceManager Class Reference

`#include <juce_AudioDeviceManager.h>`

Inheritance diagram for juce::AudioDeviceManager:

## Classes

struct | AudioDeviceSetup
struct | LevelMeter

## Public Member Functions

| AudioDeviceManager ()
| ~AudioDeviceManager () override
String | initialise (int numInputChannelsNeeded, int numOutputChannelsNeeded, const XmlElement *savedState, bool selectDefaultDeviceOnFailure, const String &preferredDefaultDeviceName=String(), const AudioDeviceSetup *preferredSetupOptions=nullptr)
String | initialiseWithDefaultDevices (int numInputChannelsNeeded, int numOutputChannelsNeeded)
std::unique_ptr< XmlElement > | createStateXml () const
AudioDeviceSetup | getAudioDeviceSetup () const
void | getAudioDeviceSetup (AudioDeviceSetup &result) const
String | setAudioDeviceSetup (const AudioDeviceSetup &newSetup, bool treatAsChosenDevice)
AudioIODevice * | getCurrentAudioDevice () const noexcept
String | getCurrentAudioDeviceType () const
AudioIODeviceType * | getCurrentDeviceTypeObject () const
void | setCurrentAudioDeviceType (const String &type, bool treatAsChosenDevice)
AudioWorkgroup | getDeviceAudioWorkgroup () const
void | closeAudioDevice ()
void | restartLastAudioDevice ()
void | addAudioCallback (AudioIODeviceCallback *newCallback)
void | removeAudioCallback (AudioIODeviceCallback *callback)
double | getCpuUsage () const
void | setMidiInputDeviceEnabled (const String &deviceIdentifier, bool enabled)
bool | isMidiInputDeviceEnabled (const String &deviceIdentifier) const
void | addMidiInputDeviceCallback (const String &deviceIdentifier, MidiInputCallback *callback)
void | removeMidiInputDeviceCallback (const String &deviceIdentifier, MidiInputCallback *callback)
void | setDefaultMidiOutputDevice (const String &deviceIdentifier)
const String & | getDefaultMidiOutputIdentifier () const noexcept
MidiOutput * | getDefaultMidiOutput () const noexcept
const OwnedArray< AudioIODeviceType > & | getAvailableDeviceTypes ()
virtual void | createAudioDeviceTypes (OwnedArray< AudioIODeviceType > &types)
void | addAudioDeviceType (std::unique_ptr< AudioIODeviceType > newDeviceType)
void | removeAudioDeviceType (AudioIODeviceType *deviceTypeToRemove)
void | playTestSound ()
LevelMeter::Ptr | getInputLevelGetter () noexcept
LevelMeter::Ptr | getOutputLevelGetter () noexcept
CriticalSection & | getAudioCallbackLock () noexcept
CriticalSection & | getMidiCallbackLock () noexcept
int | getXRunCount () const noexcept
void | setMidiInputEnabled (const String &, bool)
bool | isMidiInputEnabled (const String &) const
void | addMidiInputCallback (const String &, MidiInputCallback *)
void | removeMidiInputCallback (const String &, MidiInputCallback *)
void | setDefaultMidiOutput (const String &)
const String & | getDefaultMidiOutputName () const noexcept
Public Member Functions inherited from juce::ChangeBroadcaster
| ChangeBroadcaster () noexcept
virtual | ~ChangeBroadcaster ()
void | addChangeListener (ChangeListener *listener)
void | removeChangeListener (ChangeListener *listener)
void | removeAllChangeListeners ()
void | sendChangeMessage ()
void | sendSynchronousChangeMessage ()
void | dispatchPendingMessages ()

## Detailed Description

Manages the state of some audio and midi i/o devices.

This class keeps tracks of a currently-selected audio device, through with which it continuously streams data from an audio callback, as well as one or more midi inputs.

The idea is that your application will create one global instance of this object, and let it take care of creating and deleting specific types of audio devices internally. So when the device is changed, your callbacks will just keep running without having to worry about this.

The manager can save and reload all of its device settings as XML, which makes it very easy for you to save and reload the audio setup of your application.

And to make it easy to let the user change its settings, there's a component to do just that - the AudioDeviceSelectorComponent class, which contains a set of device selection/sample-rate/latency controls.

To use an AudioDeviceManager, create one, and use initialise() to set it up. Then call addAudioCallback() to register your audio callback with it, and use that to process your audio data.

The manager also acts as a handy hub for incoming midi messages, allowing a listener to register for messages from either a specific midi device, or from whatever the current default midi input device is. The listener then doesn't have to worry about re-registering with different midi devices if they are changed or deleted.

And yet another neat trick is that amount of CPU time being used is measured and available with the getCpuUsage() method.

The AudioDeviceManager is a ChangeBroadcaster, and will send a change message to listeners whenever one of its settings is changed.

See also
  AudioDeviceSelectorComponent, AudioIODevice, AudioIODeviceType

Definition at line 66 of file juce_AudioDeviceManager.h.

## Constructor & Destructor Documentation

## AudioDeviceManager()

juce::AudioDeviceManager::AudioDeviceManager | ( |  | ) |

Creates a default AudioDeviceManager.

Initially no audio device will be selected. You should call the initialise() method and register an audio callback with setAudioCallback() before it'll be able to actually make any noise.

Definition at line 113 of file juce_AudioDeviceManager.cpp.

## ~AudioDeviceManager()

juce::AudioDeviceManager::~AudioDeviceManager | ( |  | ) |

override

Destructor.

Definition at line 118 of file juce_AudioDeviceManager.cpp.

## Member Function Documentation

## addAudioCallback()

void juce::AudioDeviceManager::addAudioCallback | ( | AudioIODeviceCallback * | newCallback | ) |

Registers an audio callback to be used.

The manager will redirect callbacks from whatever audio device is currently in use to all registered callback objects. If more than one callback is active, they will all be given the same input data, and their outputs will be summed.

If necessary, this method will invoke audioDeviceAboutToStart() on the callback object before returning.

To remove a callback, use removeAudioCallback().

Definition at line 959 of file juce_AudioDeviceManager.cpp.

## addAudioDeviceType()

void juce::AudioDeviceManager::addAudioDeviceType | ( | std::unique_ptr< AudioIODeviceType > | newDeviceType | ) |

Adds a new device type to the list of types.

Definition at line 253 of file juce_AudioDeviceManager.cpp.

## addMidiInputCallback()

void juce::AudioDeviceManager::addMidiInputCallback | ( | const String & | name,
|  | MidiInputCallback * | callbackToAdd )

Definition at line 1328 of file juce_AudioDeviceManager.cpp.

## addMidiInputDeviceCallback()

void juce::AudioDeviceManager::addMidiInputDeviceCallback | ( | const String & | deviceIdentifier,
|  | MidiInputCallback * | callback )

Registers a listener for callbacks when midi events arrive from a midi input.

The device identifier can be empty to indicate that it wants to receive all incoming events from all the enabled MIDI inputs. Or it can be the identifier of one of the MIDI input devices if it just wants the events from that device. (see MidiInput::getAvailableDevices() for the list of devices).

Only devices which are enabled (see the setMidiInputDeviceEnabled() method) will have their events forwarded on to listeners.

Definition at line 1138 of file juce_AudioDeviceManager.cpp.

## closeAudioDevice()

void juce::AudioDeviceManager::closeAudioDevice | ( |  | ) |

Closes the currently-open device. You can call restartLastAudioDevice() later to reopen it in the same state that it was just in.

Definition at line 877 of file juce_AudioDeviceManager.cpp.

Referenced by setCurrentAudioDeviceType().

## createAudioDeviceTypes()

void juce::AudioDeviceManager::createAudioDeviceTypes | ( | OwnedArray< AudioIODeviceType > & | types | ) |

virtual

Creates a list of available types.

This will add a set of new AudioIODeviceType objects to the specified list, to represent each available types of device.

You can override this if your app needs to do something specific, like avoid using DirectSound devices, etc.

Definition at line 236 of file juce_AudioDeviceManager.cpp.

## createStateXml()

std::unique_ptr< XmlElement > juce::AudioDeviceManager::createStateXml | ( |  | ) | const

Returns some XML representing the current state of the manager.

This stores the current device, its samplerate, block size, etc, and can be restored later with initialise().

Note that this can return a null pointer if no settings have been explicitly changed (i.e. if the device manager has just been left in its default state).

Definition at line 596 of file juce_AudioDeviceManager.cpp.

## getAudioCallbackLock()

CriticalSection & juce::AudioDeviceManager::getAudioCallbackLock | ( |  | ) |

inline noexcept

Returns the a lock that can be used to synchronise access to the audio callback. Obviously while this is locked, you're blocking the audio thread from running, so it must only be used for very brief periods when absolutely necessary.

Definition at line 459 of file juce_AudioDeviceManager.h.

## getAudioDeviceSetup() [1/2]

AudioDeviceManager::AudioDeviceSetup juce::AudioDeviceManager::getAudioDeviceSetup | ( |  | ) | const

Returns the current device properties that are in use.

See also
  setAudioDeviceSetup

Definition at line 641 of file juce_AudioDeviceManager.cpp.

## getAudioDeviceSetup() [2/2]

void juce::AudioDeviceManager::getAudioDeviceSetup | ( | AudioDeviceSetup & | result | ) | const

Returns the current device properties that are in use. This is an old method, kept around for compatibility, but you should prefer the new version which returns the result rather than taking an out-parameter.

See also
  getAudioDeviceSetup()

Definition at line 646 of file juce_AudioDeviceManager.cpp.

## getAvailableDeviceTypes()

const OwnedArray< AudioIODeviceType > & juce::AudioDeviceManager::getAvailableDeviceTypes | ( |  | ) |

Returns a list of the types of device supported.

Definition at line 164 of file juce_AudioDeviceManager.cpp.

## getCpuUsage()

double juce::AudioDeviceManager::getCpuUsage | ( |  | ) | const

Returns the average proportion of available CPU being spent inside the audio callbacks.

Returns
  A value between 0 and 1.0 to indicate the approximate proportion of CPU time spent in the callbacks.

Definition at line 1099 of file juce_AudioDeviceManager.cpp.

## getCurrentAudioDevice()

AudioIODevice * juce::AudioDeviceManager::getCurrentAudioDevice | ( |  | ) | const

inline noexcept

Returns the currently-active audio device.

Definition at line 243 of file juce_AudioDeviceManager.h.

## getCurrentAudioDeviceType()

String juce::AudioDeviceManager::getCurrentAudioDeviceType | ( |  | ) | const

inline

Returns the type of audio device currently in use.

See also
  setCurrentAudioDeviceType

Definition at line 248 of file juce_AudioDeviceManager.h.

## getCurrentDeviceTypeObject()

AudioIODeviceType * juce::AudioDeviceManager::getCurrentDeviceTypeObject | ( |  | ) | const

Returns the currently active audio device type object. Don't keep a copy of this pointer - it's owned by the device manager and could change at any time.

Definition at line 690 of file juce_AudioDeviceManager.cpp.

Referenced by setAudioDeviceSetup().

## getDefaultMidiOutput()

MidiOutput * juce::AudioDeviceManager::getDefaultMidiOutput | ( |  | ) | const

inline noexcept

Returns the current default midi output device. If no device has been selected, or the device can't be opened, this will return nullptr.

See also
  getDefaultMidiOutputIdentifier

Definition at line 386 of file juce_AudioDeviceManager.h.

## getDefaultMidiOutputIdentifier()

const String & juce::AudioDeviceManager::getDefaultMidiOutputIdentifier | ( |  | ) | const

inline noexcept

Returns the name of the default midi output.

See also
  setDefaultMidiOutputDevice, getDefaultMidiOutput

Definition at line 379 of file juce_AudioDeviceManager.h.

## getDefaultMidiOutputName()

const String & juce::AudioDeviceManager::getDefaultMidiOutputName | ( |  | ) | const

inline noexcept

Definition at line 489 of file juce_AudioDeviceManager.h.

## getDeviceAudioWorkgroup()

AudioWorkgroup juce::AudioDeviceManager::getDeviceAudioWorkgroup | ( |  | ) | const

Returns the current audio device workgroup, if supported.

Definition at line 685 of file juce_AudioDeviceManager.cpp.

## getInputLevelGetter()

LevelMeter::Ptr juce::AudioDeviceManager::getInputLevelGetter | ( |  | ) |

inline noexcept

Returns a reference-counted object that can be used to get the current input level.

You need to store this object locally to ensure that the reference count is incremented and decremented properly. The current input level value can be read using getCurrentLevel().

Definition at line 445 of file juce_AudioDeviceManager.h.

## getMidiCallbackLock()

CriticalSection & juce::AudioDeviceManager::getMidiCallbackLock | ( |  | ) |

inline noexcept

Returns the a lock that can be used to synchronise access to the midi callback. Obviously while this is locked, you're blocking the midi system from running, so it must only be used for very brief periods when absolutely necessary.

Definition at line 465 of file juce_AudioDeviceManager.h.

## getOutputLevelGetter()

LevelMeter::Ptr juce::AudioDeviceManager::getOutputLevelGetter | ( |  | ) |

inline noexcept

Returns a reference-counted object that can be used to get the current output level.

You need to store this object locally to ensure that the reference count is incremented and decremented properly. The current output level value can be read using getCurrentLevel().

Definition at line 452 of file juce_AudioDeviceManager.h.

## getXRunCount()

int juce::AudioDeviceManager::getXRunCount | ( |  | ) | const

noexcept

Returns the number of under- or over runs reported.

This method will use the underlying device's native getXRunCount if it supports it. Otherwise it will estimate the number of under-/overruns by measuring the time it spent in the audio callback.

Definition at line 1299 of file juce_AudioDeviceManager.cpp.

## initialise()

String juce::AudioDeviceManager::initialise | ( | int | numInputChannelsNeeded,
|  | int | numOutputChannelsNeeded,
|  | const XmlElement * | savedState,
|  | bool | selectDefaultDeviceOnFailure,
|  | const String & | preferredDefaultDeviceName = String(),
|  | const AudioDeviceSetup * | preferredSetupOptions = nullptr )

Opens a set of audio devices ready for use.

This will attempt to open either a default audio device, or one that was previously saved as XML.

Parameters

  numInputChannelsNeeded | the maximum number of input channels your app would like to use (the actual number of channels opened may be less than the number requested)
  numOutputChannelsNeeded | the maximum number of output channels your app would like to use (the actual number of channels opened may be less than the number requested)
  savedState | either a previously-saved state that was produced by createStateXml(), or nullptr if you want the manager to choose the best device to open.
  selectDefaultDeviceOnFailure | if true, then if the device specified in the XML fails to open, then a default device will be used instead. If false, then on failure, no device is opened.
  preferredDefaultDeviceName | if this is not empty, and there's a device with this name, then that will be used as the default device (assuming that there wasn't one specified in the XML). The string can actually be a simple wildcard, containing "*" and "?" characters
  preferredSetupOptions | if this is non-null, the structure will be used as the set of preferred settings when opening the device. If you use this parameter, the preferredDefaultDeviceName field will be ignored. If you set the outputDeviceName or inputDeviceName data members of the AudioDeviceSetup to empty strings, then a default device will be used.

Returns
  an error message if anything went wrong, or an empty string if it worked ok.

Definition at line 292 of file juce_AudioDeviceManager.cpp.

Referenced by initialiseWithDefaultDevices().

## initialiseWithDefaultDevices()

String juce::AudioDeviceManager::initialiseWithDefaultDevices | ( | int | numInputChannelsNeeded,
|  | int | numOutputChannelsNeeded )

Resets everything to a default device setup, clearing any stored settings.

Definition at line 497 of file juce_AudioDeviceManager.cpp.

## isMidiInputDeviceEnabled()

bool juce::AudioDeviceManager::isMidiInputDeviceEnabled | ( | const String & | deviceIdentifier | ) | const

Returns true if a given midi input device is being used.

See also
  setMidiInputDeviceEnabled

Definition at line 1129 of file juce_AudioDeviceManager.cpp.

Referenced by addMidiInputDeviceCallback(), and setMidiInputDeviceEnabled().

## isMidiInputEnabled()

bool juce::AudioDeviceManager::isMidiInputEnabled | ( | const String & | name | ) | const

Definition at line 1319 of file juce_AudioDeviceManager.cpp.

## playTestSound()

void juce::AudioDeviceManager::playTestSound | ( |  | ) |

Plays a beep through the current audio device.

This is here to allow the audio setup UI panels to easily include a "test" button so that the user can check where the audio is coming from.

Definition at line 1261 of file juce_AudioDeviceManager.cpp.

## removeAudioCallback()

void juce::AudioDeviceManager::removeAudioCallback | ( | AudioIODeviceCallback * | callback | ) |

Deregisters a previously added callback.

If necessary, this method will invoke audioDeviceStopped() on the callback object before returning.

See also
  addAudioCallback

Definition at line 975 of file juce_AudioDeviceManager.cpp.

## removeAudioDeviceType()

void juce::AudioDeviceManager::removeAudioDeviceType | ( | AudioIODeviceType * | deviceTypeToRemove | ) |

Removes a previously added device type from the manager.

Definition at line 266 of file juce_AudioDeviceManager.cpp.

## removeMidiInputCallback()

void juce::AudioDeviceManager::removeMidiInputCallback | ( | const String & | name,
|  | MidiInputCallback * | callbackToRemove )

Definition at line 1347 of file juce_AudioDeviceManager.cpp.

## removeMidiInputDeviceCallback()

void juce::AudioDeviceManager::removeMidiInputDeviceCallback | ( | const String & | deviceIdentifier,
|  | MidiInputCallback * | callback )

Removes a listener that was previously registered with addMidiInputDeviceCallback().

Definition at line 1149 of file juce_AudioDeviceManager.cpp.

Referenced by addMidiInputDeviceCallback().

## restartLastAudioDevice()

void juce::AudioDeviceManager::restartLastAudioDevice | ( |  | ) |

Tries to reload the last audio device that was running.

Note that this only reloads the last device that was running before closeAudioDevice() was called - it doesn't reload any kind of saved-state, and can only be called after a device has been opened with setAudioDeviceSetup().

If a device is already open, this call will do nothing.

Definition at line 884 of file juce_AudioDeviceManager.cpp.

## setAudioDeviceSetup()

String juce::AudioDeviceManager::setAudioDeviceSetup | ( | const AudioDeviceSetup & | newSetup,
|  | bool | treatAsChosenDevice )

Changes the current device or its settings.

If you want to change a device property, like the current sample rate or block size, you can call getAudioDeviceSetup() to retrieve the current settings, then tweak the appropriate fields in the AudioDeviceSetup structure, and pass it back into this method to apply the new settings.

Parameters

  newSetup | the settings that you'd like to use. If you don't need an input or output device, set the inputDeviceName or outputDeviceName data members respectively to empty strings. Note that this behaviour differs from the behaviour of initialise().

  treatAsChosenDevice

  if this is true and if the device opens correctly, these new settings will be taken as having been explicitly chosen by the user, and the next time createStateXml() is called, these settings will be returned. If it's false, then the device is treated as a temporary or default device, and a call to createStateXml() will return either the last settings that were made with treatAsChosenDevice as true, or the last XML settings that were passed into initialise().

Returns
  an error message if anything went wrong, or an empty string if it worked ok.

See also
  getAudioDeviceSetup

Definition at line 718 of file juce_AudioDeviceManager.cpp.

Referenced by restartLastAudioDevice(), and setCurrentAudioDeviceType().

## setCurrentAudioDeviceType()

void juce::AudioDeviceManager::setCurrentAudioDeviceType | ( | const String & | type,
|  | bool | treatAsChosenDevice )

Changes the class of audio device being used.

This switches between, e.g. ASIO and DirectSound. On the Mac you probably won't ever call this because there's only one type: CoreAudio.

For a list of types, see getAvailableDeviceTypes().

Definition at line 658 of file juce_AudioDeviceManager.cpp.

## setDefaultMidiOutput()

void juce::AudioDeviceManager::setDefaultMidiOutput | ( | const String & | name | ) |

Definition at line 1366 of file juce_AudioDeviceManager.cpp.

## setDefaultMidiOutputDevice()

void juce::AudioDeviceManager::setDefaultMidiOutputDevice | ( | const String & | deviceIdentifier | ) |

Sets a midi output device to use as the default.

The list of devices can be obtained with the MidiOutput::getAvailableDevices() method.

The specified device will be opened automatically and can be retrieved with the getDefaultMidiOutput() method.

Pass in an empty string to deselect all devices. For the default device, you can use MidiOutput::getDefaultDevice().

See also
  getDefaultMidiOutput, getDefaultMidiOutputIdentifier

Definition at line 1176 of file juce_AudioDeviceManager.cpp.

## setMidiInputDeviceEnabled()

void juce::AudioDeviceManager::setMidiInputDeviceEnabled | ( | const String & | deviceIdentifier,
|  | bool | enabled )

Enables or disables a midi input device.

The list of devices can be obtained with the MidiInput::getAvailableDevices() method.

Any incoming messages from enabled input devices will be forwarded on to all the listeners that have been registered with the addMidiInputDeviceCallback() method. They can either register for messages from a particular device, or from just the "default" midi input.

Routing the midi input via an AudioDeviceManager means that when a listener registers for the default midi input, this default device can be changed by the manager without the listeners having to know about it or re-register.

It also means that a listener can stay registered for a midi input that is disabled or not present, so that when the input is re-enabled, the listener will start receiving messages again.

See also
  addMidiInputDeviceCallback, isMidiInputDeviceEnabled

Definition at line 1105 of file juce_AudioDeviceManager.cpp.

## setMidiInputEnabled()

void juce::AudioDeviceManager::setMidiInputEnabled | ( | const String & | name,
|  | bool | enabled )

Definition at line 1307 of file juce_AudioDeviceManager.cpp.

The documentation for this class was generated from the following files:

- juce_AudioDeviceManager.h
- juce_AudioDeviceManager.cpp